//+------------------------------------------------------------------+
//| SilverTrend .mq4 |
//| SilverTrend rewritten by CrazyChart |
//| URL Removed by Forum Admin |
//+------------------------------------------------------------------+
#property copyright "SilverTrend rewritten by CrazyChart"
#property link ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue //Red //Aqua
#property indicator_color2 Red
//---- input parameters

double buycntr , sellcntr;
extern int SSP=7;
extern double Kmin=1.6;
extern double Kmax=50.6; //24 21.6 21.6
extern int CountBars=300;
extern int DistanceAlert=35;

string short_name;
int at,last;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];
double up , down ,val1prev , val2prev;

//buycntr=0;
//sellcntr=0;
//up=1;
//down=1;


//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,trend);

   //===============SHORT NAME========================================
   short_name="FxTrend("+SSP+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{

return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{

if (CountBars>=Bars) CountBars=Bars;
SetIndexDrawBegin(0,Bars-CountBars+SSP);
SetIndexDrawBegin(1,Bars-CountBars+SSP);
int i, i2,loopbegin,counted_bars=IndicatorCounted();
double SsMax, SsMin, K, val1, val2, smin, smax, price;

if(Bars<=SSP+1) return(0);
//---- initial zero

//K=33-RISK;

/*
if (firstTime==true) {
loopbegin = CountBars;
if (loopbegin>(Bars-2*SSP+1)) loopbegin=Bars-2*SSP+1;
firstTime=False;
};   
*/
if(Bars<=SSP+1) return(0);
//---- initial zero

//+++++++
if(counted_bars<SSP+1)
{
for(i=1;i<=SSP;i++) ExtMapBuffer1[CountBars-i]=0.0;
for(i=1;i<=SSP;i++) ExtMapBuffer2[CountBars-i]=0.0;
}
//+++++++-SSP


for(i=CountBars-SSP;i>=0;i--)
{
   SsMax = High[Highest(NULL,0,MODE_HIGH,SSP,i-SSP+1)];
   SsMin = Low[Lowest(NULL,0,MODE_LOW,SSP,i-SSP+1)];
   smin  = SsMin-(SsMax-SsMin)*Kmin/100;
   smax  = SsMax-(SsMax-SsMin)*Kmax/100;
      ExtMapBuffer3[i-SSP+6]=smax;
      ExtMapBuffer4[i-SSP-1]=smax;
}
for(i=CountBars-SSP;i>=0;i--)
{
   trend[i] = trend[i+1];
   if (ExtMapBuffer3[i]>ExtMapBuffer4[i]) trend[i] =  1;
   if (ExtMapBuffer3[i]<ExtMapBuffer4[i]) trend[i] = -11;
   if (trend[i]==1)
   {
         ExtMapBuffer1[i]=High[i];
         ExtMapBuffer2[i]=Low[i];
   }
   else         
   {
         ExtMapBuffer2[i]=High[i];
         ExtMapBuffer1[i]=Low[i];
   }
}   
return(0);
}